/***********************************/
/*   Testbench for Code 11.24      */
/***********************************/
`resetall
`define PERIOD 20

module tb_shifter;

   parameter Len = 8;
   reg            clk, rst, en, wr, rd, sin;
   reg [Len-1:0]  data_in;
   wire [Len-1:0] data_io;
   wire           sout; 
   
   shifter U0_shifter (clk, rst, en, wr, rd, sin, sout, data_io);
   
   assign data_io = data_in;
   
   initial begin
     clk = 1'b0;
     forever #(`PERIOD/2) clk = ~clk;
   end
      
   initial
   begin
      #0           rst = 1'b0;
                    en = 1'b1;
                    wr = 1'b1;
                    rd = 1'b1;
                   sin = 1'b1;
               data_in = 8'bz;
      #(`PERIOD+5) rst = 1'b1; 
                    en = 1'b0;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b1;rd = 1'b0;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) rd = 1'b1;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) en =1'b1;
                 wr = 1'b0;
            data_in = 8'b1010_1001;
      #(`PERIOD) wr = 1'b1;
                 rd = 1'b1;
                 en =1'b0;
            data_in = 8'bz;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD) sin = 1'b1;
      #(`PERIOD) sin = 1'b0;
      #(`PERIOD*15) $stop;
   end
   
endmodule   
